<template>
  <div class="container-main" ref="main">
    <div class="search-hearder" ref="topSearch">
      <el-form
        :model="queryParams"
        ref="queryForm"
        :inline="true"
        v-show="showSearch"
        label-width="auto"
      >
        <el-form-item label="名称" prop="cityName">
          <el-input
            v-model="queryParams.cityName"
            placeholder="请输入名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item label="占比" prop="zb">
          <el-input
            v-model="queryParams.zb"
            placeholder="请输入占比"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div class="layui-table-tool" ref="tableTool">
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd()"
        v-hasPermi="['tcZz/networkSecurity:fbqk:add']"
        >新增</el-button
      >
      <el-button
        type="success"
        size="mini"
        :disabled="single"
        @click="handleUpdate"
        v-hasPermi="['tcZz/networkSecurity:fbqk:edit']"
        >修改</el-button
      >
      <el-button
        type="danger"
        size="mini"
        :disabled="multiple"
        @click="handleDelete"
        v-hasPermi="['tcZz/networkSecurity:fbqk:remove']"
        >删除</el-button
      >
      <el-button type="primary" size="mini" @click="importFiles"
        >导入</el-button
      >
      <el-button
        type="warning"
        size="mini"
        :loading="exportLoading"
        @click="handleExport"
        v-hasPermi="['tcZz/networkSecurity:fbqk:export']"
        >导出</el-button
      >
    </div>
    <el-table
      v-loading="loading"
      :data="fbqkList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="名称" align="center" prop="cityName" />
      <el-table-column label="占比" align="center" prop="zb" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="200"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            @click="handleInfo(scope.row)"
            v-hasPermi="['tcZz/networkSecurity:fbqk:list']"
          >
            查看
          </el-button>
          <el-button
            type="success"
            size="mini"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['tcZz/networkSecurity:fbqk:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="danger"
            @click="handleDelete(scope.row)"
            v-hasPermi="['tcZz/networkSecurity:fbqk:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改分布情况 tc_fbqk对话框 -->
    <el-dialog
      :visible.sync="open"
      width="500px"
      append-to-body
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ title }}</div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="auto"
        class="dialog-from"
      >
        <el-form-item label="名称" prop="cityName">
          <el-input v-model="form.cityName" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="占比" prop="zb">
          <el-input v-model="form.zb" placeholder="请输入占比" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--查看分布情况 tc_fbqk详情页-->
    <el-dialog
      :visible.sync="infoOpen"
      width="90%"
      append-to-body
      :close-on-click-modal="false"
      :destroy-on-close="true"
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ infoTitle }}</div>

      <el-descriptions
        title="分布情况 tc_fbqk"
        :column="2"
        border
        labelClassName="desLable"
      >
        <el-descriptions-item label="名称">{{
          form.cityName
        }}</el-descriptions-item>

        <el-descriptions-item label="占比">{{ form.zb }}</el-descriptions-item>

        <el-descriptions-item label="备注">{{
          form.remark
        }}</el-descriptions-item>
      </el-descriptions>
    </el-dialog>
    <!-- 导入 -->
    <el-dialog
      :visible.sync="fileOpen"
      width="400px"
      append-to-body
      custom-class="dialog-box"
      @close="cancelFile"
    >
      <div slot="title" class="dialog-title">导入</div>
      <el-upload
        ref="upload"
        :limit="limit"
        action="666"
        :accept="accept"
        :headers="headers"
        :file-list="fileList"
        :multiple="false"
        :auto-upload="false"
        drag
        :before-upload="handleBeforeUpload"
        :on-exceed="handleExceed"
        :http-request="handleFile"
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <div class="el-upload__tip text-center" slot="tip">
          <span>仅允许导入xls、xlsx格式文件。</span>
          <el-link
            type="primary"
            :underline="false"
            style="font-size: 12px; vertical-align: baseline"
            @click="importTemplate"
            >下载模板</el-link
          >
        </div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFile">确 定</el-button>
        <el-button @click="cancelFile">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listFbqk,
  getFbqk,
  delFbqk,
  addFbqk,
  updateFbqk,
  exportFbqk,
  importFbqk,
} from "@/api/tcZz/networkSecurity/fbqk";
import { getToken } from "@/utils/auth";

export default {
  name: "Fbqk",
  //注释字典
  data() {
    return {
      tableHeigth: 0,
      //查看详情
      infoOpen: false,
      //详情标题
      infoTitle: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 分布情况 tc_fbqk表格数据
      fbqkList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 备注时间范围
      daterangeCreateTime: [],
      // 备注时间范围
      daterangeUpdateTime: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        id: null,

        cityName: null,

        zb: null,

        createBy: null,

        createTime: null,

        updateBy: null,

        updateTime: null,

        remark: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      //===========
      fileList: [],
      limit: 1,
      accept: ".xls,.xlsx",
      fileOpen: false,
      headers: { Authorization: "Bearer " + getToken() },
    };
  },
  created() {
    this.getList();
  },
  methods: {
      //下载模板
      importTemplate() {
      this.download(
        "/tcZz/networkSecurity/fbqk/importTemplate",
        {},
        `分布情况模板.xlsx`
      );
    },
    importFiles() {
      this.fileOpen = true;
    },
    submitFile() {
      this.$refs.upload.submit();
    },
    cancelFile() {
      this.fileOpen = false;
    },
    //导入
    handleBeforeUpload(file) {
      // 校检文件类型
      const fileName = file.name.split(".");
      const fileExt = fileName[fileName.length - 1];
      const isTypeOk = this.accept.includes(fileExt);
      if (!isTypeOk) {
        this.$modal.msgError(`文件格式不正确, 请上传${this.accept}格式文件!`);
        return false;
      }
    },
    handleExceed() {
      this.$modal.msgError(`上传文件数量不能超过 ${this.limit} 个!`);
    },
    handleFile(data) {
      this.$modal.loading();
      let form = new FormData();
      form.append("file", data.file);
      importFbqk(form)
        .then((res) => {
          this.fileOpen = false;
          this.$modal.closeLoading();
          this.$modal.msgSuccess("导入成功");
          this.$refs.upload.clearFiles();
          this.getList();
        })
        .catch(() => {
          this.fileOpen = false;
          this.$modal.closeLoading();
          this.$refs.upload.clearFiles();
          this.getList();
        });
    },
    /** 查询分布情况 tc_fbqk列表 */
    getList() {
      this.loading = true;
      this.queryParams.params = {};
      if (null != this.daterangeCreateTime && "" != this.daterangeCreateTime) {
        this.queryParams.params["beginCreateTime"] =
          this.daterangeCreateTime[0];
        this.queryParams.params["endCreateTime"] = this.daterangeCreateTime[1];
      }
      if (null != this.daterangeUpdateTime && "" != this.daterangeUpdateTime) {
        this.queryParams.params["beginUpdateTime"] =
          this.daterangeUpdateTime[0];
        this.queryParams.params["endUpdateTime"] = this.daterangeUpdateTime[1];
      }
      listFbqk(this.queryParams).then((response) => {
        this.fbqkList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,

        cityName: null,

        zb: null,

        createBy: null,

        createTime: null,

        updateBy: null,

        updateTime: null,

        remark: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeCreateTime = [];
      this.daterangeUpdateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /**查看按钮操作 */
    handleInfo(row) {
      this.reset();
      const id = row.id || this.ids;
      getFbqk(id).then((response) => {
        this.form = response.data;
        this.infoOpen = true;
        this.infoTitle = "查看分布情况 tc_fbqk详情";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加分布情况 tc_fbqk";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getFbqk(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改分布情况 tc_fbqk";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateFbqk(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addFbqk(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delFbqk(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有分布情况 tc_fbqk数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.download(
            "/tcZz/networkSecurity/fbqk/export",
            {
              ...this.queryParams,
            },
            "分布情况 tc_fbqk_" + new Date().getTime() + ".xlsx"
          );
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
